From 6e01919b9075ec95c5726e3405f2be7760f4562c Mon Sep 17 00:00:00 2001
From: Egbert Eich <eich@suse.com>
Date: Mon, 16 May 2022 14:33:14 +0200
Subject: [PATCH 22/30] Replace response_init()

Signed-off-by: Egbert Eich <eich@suse.com>
---
 src/slurmctld/job_mgr.c  |  4 ++
 src/slurmctld/proc_req.c | 82 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 86 insertions(+)

diff --git a/src/slurmctld/job_mgr.c b/src/slurmctld/job_mgr.c
index 869be5b28f..6070b55f9f 100644
--- a/src/slurmctld/job_mgr.c
+++ b/src/slurmctld/job_mgr.c
@@ -13923,6 +13923,8 @@ extern int update_job_str(slurm_msg_t *msg, uid_t uid)
 reply:
 	if ((rc != ESLURM_JOB_SETTING_DB_INX) && (msg->conn_fd >= 0)) {
 	        slurm_msg_t_init(&resp_msg);
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		if (resp_array) {
 			resp_array_msg = _resp_array_xlate(resp_array, job_id);
 			resp_msg.msg_type  = RESPONSE_JOB_ARRAY_ERRORS;
@@ -16478,6 +16480,8 @@ extern int job_requeue2(uid_t uid, requeue_msg_t *req_ptr, slurm_msg_t *msg,
     reply:
 	if (msg) {
 		slurm_msg_t_init(&resp_msg);
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		resp_msg.protocol_version = msg->protocol_version;
 		resp_msg.conn             = msg->conn;
 		if (resp_array) {
diff --git a/src/slurmctld/proc_req.c b/src/slurmctld/proc_req.c
index 3362e53572..5b0a350201 100644
--- a/src/slurmctld/proc_req.c
+++ b/src/slurmctld/proc_req.c
@@ -1537,6 +1537,8 @@ static void _slurm_rpc_allocate_pack(slurm_msg_t * msg)
 		response_msg.conn = msg->conn;
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type = RESPONSE_JOB_PACK_ALLOCATION;
 		response_msg.data = resp;
 
@@ -1756,6 +1758,8 @@ send_msg:
 		response_msg.conn = msg->conn;
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		     slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type = RESPONSE_RESOURCE_ALLOCATION;
 		response_msg.data = alloc_msg;
 
@@ -1834,6 +1838,8 @@ static void _slurm_rpc_dump_conf(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_BUILD_INFO;
@@ -1889,6 +1895,8 @@ static void _slurm_rpc_dump_jobs(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -1931,6 +1939,8 @@ static void _slurm_rpc_dump_jobs_user(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -1975,6 +1985,8 @@ static void _slurm_rpc_dump_job_single(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_INFO;
@@ -2004,6 +2016,8 @@ static void  _slurm_rpc_get_shares(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_SHARE_INFO;
@@ -2033,6 +2047,8 @@ static void  _slurm_rpc_get_priority_factors(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_PRIORITY_FACTORS;
@@ -2071,6 +2087,8 @@ static void _slurm_rpc_end_time(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address  = msg->address;
 		response_msg.conn     = msg->conn;
 		response_msg.msg_type = SRUN_TIMEOUT;
@@ -2099,6 +2117,8 @@ static void _slurm_rpc_get_fed(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_FED_INFO;
@@ -2147,6 +2167,8 @@ static void _slurm_rpc_dump_front_end(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_FRONT_END_INFO;
@@ -2207,6 +2229,8 @@ static void _slurm_rpc_dump_nodes(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_NODE_INFO;
@@ -2265,6 +2289,8 @@ static void _slurm_rpc_dump_node_single(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_NODE_INFO;
@@ -2318,6 +2344,8 @@ static void _slurm_rpc_dump_partitions(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_PARTITION_INFO;
@@ -2802,6 +2830,8 @@ static void  _slurm_rpc_dump_batch_script(slurm_msg_t *msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_BATCH_SCRIPT;
@@ -2932,6 +2962,8 @@ static void _slurm_rpc_job_step_create(slurm_msg_t * msg)
 		slurm_msg_t_init(&resp);
 		resp.flags = msg->flags;
 		resp.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp, msg->auth_uid);
 		resp.address = msg->address;
 		resp.conn = msg->conn;
 		resp.msg_type = RESPONSE_JOB_STEP_CREATE;
@@ -3001,6 +3033,8 @@ static void _slurm_rpc_job_step_get_info(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_STEP_INFO;
@@ -3108,6 +3142,8 @@ send_reply:
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_JOB_WILL_RUN;
@@ -3309,6 +3345,8 @@ static void _slurm_rpc_job_alloc_info(slurm_msg_t * msg)
 		response_msg.data     = job_info_resp_msg;
 		response_msg.flags    = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 
 		slurm_send_node_msg(msg->conn_fd, &response_msg);
 
@@ -3413,6 +3451,8 @@ static void _slurm_rpc_job_pack_alloc_info(slurm_msg_t * msg)
 	response_msg.data     = resp;
 	response_msg.flags    = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	slurm_send_node_msg(msg->conn_fd, &response_msg);
 	FREE_NULL_LIST(resp);
 }
@@ -3655,6 +3695,8 @@ static void _slurm_rpc_job_sbcast_cred(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.msg_type    = RESPONSE_JOB_SBCAST_CRED;
 		response_msg.data        = &job_info_resp_msg;
 
@@ -4031,6 +4073,8 @@ static void _slurm_rpc_step_layout(slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.msg_type    = RESPONSE_STEP_LAYOUT;
 	response_msg.data        = step_layout;
 
@@ -4209,6 +4253,8 @@ send_msg:
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_SUBMIT_BATCH_JOB;
 		response_msg.data = &submit_msg;
@@ -4506,6 +4552,8 @@ send_msg:
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_SUBMIT_BATCH_JOB;
 		response_msg.data = &submit_msg;
@@ -5017,6 +5065,8 @@ static void _slurm_rpc_resv_create(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		memset(&resv_resp_msg, 0, sizeof(resv_resp_msg));
 		resv_resp_msg.name    = resv_desc_ptr->name;
 		response_msg.msg_type = RESPONSE_CREATE_RESERVATION;
@@ -5148,6 +5198,8 @@ static void _slurm_rpc_resv_show(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_RESERVATION_INFO;
@@ -5204,6 +5256,8 @@ static void _slurm_rpc_layout_show(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_LAYOUT_INFO;
@@ -5243,6 +5297,8 @@ static void _slurm_rpc_job_ready(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 
@@ -5306,6 +5362,8 @@ static void  _slurm_rpc_burst_buffer_info(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address = msg->address;
 		response_msg.conn = msg->conn;
 		response_msg.msg_type = RESPONSE_BURST_BUFFER_INFO;
@@ -5704,6 +5762,8 @@ inline static void  _slurm_rpc_trigger_get(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_TRIGGER_GET;
@@ -5798,6 +5858,8 @@ inline static void  _slurm_rpc_get_topo(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_TOPO_INFO;
@@ -5830,6 +5892,8 @@ inline static void  _slurm_rpc_get_powercap(slurm_msg_t * msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address  = msg->address;
 	response_msg.conn     = msg->conn;
 	response_msg.msg_type = RESPONSE_POWERCAP_INFO;
@@ -6324,6 +6388,8 @@ inline static void _slurm_rpc_dump_spank(slurm_msg_t * msg)
 		slurm_msg_t_init(&response_msg);
 		response_msg.flags = msg->flags;
 		response_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 		response_msg.address  = msg->address;
 		response_msg.conn     = msg->conn;
 		response_msg.msg_type = RESPONCE_SPANK_ENVIRONMENT;
@@ -6417,6 +6483,8 @@ inline static void _slurm_rpc_burst_buffer_status(slurm_msg_t *msg)
 
 	slurm_msg_t_init(&response_msg);
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_BURST_BUFFER_STATUS;
@@ -6438,6 +6506,8 @@ inline static void _slurm_rpc_control_status(slurm_msg_t * msg)
 
 	slurm_msg_t_init(&response_msg);
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_CONTROL_STATUS;
@@ -6473,6 +6543,8 @@ inline static void _slurm_rpc_dump_stats(slurm_msg_t * msg)
 
 	slurm_msg_t_init(&response_msg);
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_STATS_INFO;
@@ -6536,6 +6608,8 @@ _slurm_rpc_dump_licenses(slurm_msg_t * msg)
 
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_LICENSE_INFO;
@@ -6751,6 +6825,8 @@ static void  _slurm_rpc_composite_msg(slurm_msg_t *msg)
 		slurm_msg_t_init(&resp_msg);
 		resp_msg.flags    = msg->flags;
 		resp_msg.protocol_version = msg->protocol_version;
+		if (msg->auth_uid_set)
+		  slurm_msg_set_r_uid(&resp_msg, msg->auth_uid);
 		memcpy(&resp_msg.address, &comp_msg->sender,
 		       sizeof(slurm_addr_t));
 		resp_msg.msg_type = RESPONSE_MESSAGE_COMPOSITE;
@@ -6836,6 +6912,8 @@ static void  _slurm_rpc_comp_msg_list(composite_msg_t * comp_msg,
 				resp_msg->flags = next_msg->flags;
 				resp_msg->protocol_version =
 					next_msg->protocol_version;
+				if (next_msg->auth_uid_set)
+				  slurm_msg_set_r_uid(resp_msg, next_msg->auth_uid);
 				resp_msg->msg_type = RESPONSE_MESSAGE_COMPOSITE;
 				/* You can't just set the
 				 * resp_msg->address here, it won't
@@ -6911,6 +6989,8 @@ static void _slurm_rpc_assoc_mgr_info(slurm_msg_t * msg)
 
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_ASSOC_MGR_INFO;
@@ -7180,6 +7260,8 @@ static void _proc_multi_msg(uint32_t rpc_uid, slurm_msg_t *msg)
 	slurm_msg_t_init(&response_msg);
 	response_msg.flags = msg->flags;
 	response_msg.protocol_version = msg->protocol_version;
+	if (msg->auth_uid_set)
+	  slurm_msg_set_r_uid(&response_msg, msg->auth_uid);
 	response_msg.address = msg->address;
 	response_msg.conn = msg->conn;
 	response_msg.msg_type = RESPONSE_CTLD_MULT_MSG;
-- 
2.35.3


